# Summary

 Members                        | Descriptions                                
--------------------------------|---------------------------------------------
`public Logger `[`log`](#_s_c16_i_s740_r_k_8cpp_1ab0cb28e7a6cc0d1fd43bf69bca5088c2)`("app.ser")`            | 
`class `[`SC16IS740`](#class_s_c16_i_s740) | Library for using the [SC16IS740](#class_s_c16_i_s740) UART on the Particle platform.

## Members

#### `public Logger `[`log`](#_s_c16_i_s740_r_k_8cpp_1ab0cb28e7a6cc0d1fd43bf69bca5088c2)`("app.ser")` 

# class `SC16IS740` 

```
class SC16IS740
  : public Stream
```  

Library for using the [SC16IS740](#class_s_c16_i_s740) UART on the Particle platform.

## Summary

 Members                        | Descriptions                                
--------------------------------|---------------------------------------------
`public  `[`SC16IS740`](#class_s_c16_i_s740_1a48a15f05e738b52cca9549046b6360c5)`(TwoWire & wire,int addr,int intPin)` | Construct the UART object. Typically done as a global variable.
`public virtual  `[`~SC16IS740`](#class_s_c16_i_s740_1a0323daa72d8615cc2e048de05d51103c)`()` | 
`public inline `[`SC16IS740`](#class_s_c16_i_s740)` & `[`withOscillatorHz`](#class_s_c16_i_s740_1a2bade8e74f73cd4175b295d7f6e620ce)`(int value)` | Set the oscillator frequency in Hz (default: 1843200)
`public void `[`begin`](#class_s_c16_i_s740_1a2914d7b2eb94a0d9413c295611814cd2)`(int baudRate,uint8_t options)` | Set up the chip. You must do this before reading or writing.
`public inline void `[`blockOnOverrun`](#class_s_c16_i_s740_1a146f0afeb2d5efe71d2c44285a8260dd)`(bool value)` | Defines what should happen when calls to [write()](#class_s_c16_i_s740_1ae95bfe10661800710fb0c3ed399dd6da)/print()/println()/printlnf() that would overrun the buffer.
`public virtual int `[`available`](#class_s_c16_i_s740_1a9e1cf50a2edb0d20e801ce85b17dff79)`()` | Returns the number of bytes available to read from the serial port.
`public virtual int `[`availableForWrite`](#class_s_c16_i_s740_1a5a74760f6ca7cf61f72fdcf9f104b5f2)`()` | Returns the number of bytes available to write into the TX FIFO.
`public virtual int `[`read`](#class_s_c16_i_s740_1a2e8cf54d3fc3b8d4a06ea7e0f99fe6d6)`()` | Read a single byte from the serial port.
`public virtual int `[`peek`](#class_s_c16_i_s740_1a6f917ad00ab6a191d40966d65f0f4f9a)`()` | Read a single byte from the serial port, but do not remove it so it can be read again.
`public virtual void `[`flush`](#class_s_c16_i_s740_1a4dc8f7f3e110f593bae82b7ebf3086cd)`()` | Block until all serial data is sent.
`public virtual size_t `[`write`](#class_s_c16_i_s740_1ae95bfe10661800710fb0c3ed399dd6da)`(uint8_t c)` | Write a single byte to the seria; port.
`public uint8_t `[`readRegister`](#class_s_c16_i_s740_1a04816f20154a877aa8b69106faedb0e6)`(uint8_t reg)` | Read a register.
`public bool `[`writeRegister`](#class_s_c16_i_s740_1af209b4f8aebfc6aabfd4b716fb96d975)`(uint8_t reg,uint8_t value)` | Write a register.
`protected TwoWire & `[`wire`](#class_s_c16_i_s740_1a1bcb2e3f74d01dc0c6296da93e6c9078) | 
`protected int `[`addr`](#class_s_c16_i_s740_1a4712027447ef4c0654a134b0bd0e7842) | 
`protected int `[`intPin`](#class_s_c16_i_s740_1a3a4b24cfd08206f9886dcf6fe4df7464) | 
`protected int `[`oscillatorHz`](#class_s_c16_i_s740_1ade63edce36c9035767bda30d1310cc9b) | 
`protected bool `[`hasPeek`](#class_s_c16_i_s740_1a00eeddab159d76a80a698be224aedab5) | 
`protected uint8_t `[`peekByte`](#class_s_c16_i_s740_1ab60b262f76c76efeb58bfcab9bae68a8) | 
`protected bool `[`writeBlocksWhenFull`](#class_s_c16_i_s740_1a867c8bbf95666bb2eb208cc328bba7cc) | 

## Members

#### `public  `[`SC16IS740`](#class_s_c16_i_s740_1a48a15f05e738b52cca9549046b6360c5)`(TwoWire & wire,int addr,int intPin)` 

Construct the UART object. Typically done as a global variable.

#### Parameters
* `wire` The I2C port to use, typically Wire.

* `addr` The address you've set using the A0 and A1 pins, 0-3. This will be converted to the appropriate I2C address. Or you can directly specify the actual I2C address 0-127.

* `intPin` The interrupt pin (-1 = not used). Note: interrupts are not currently supported.

#### `public virtual  `[`~SC16IS740`](#class_s_c16_i_s740_1a0323daa72d8615cc2e048de05d51103c)`()` 

#### `public inline `[`SC16IS740`](#class_s_c16_i_s740)` & `[`withOscillatorHz`](#class_s_c16_i_s740_1a2bade8e74f73cd4175b295d7f6e620ce)`(int value)` 

Set the oscillator frequency in Hz (default: 1843200)

You must call this before begin

#### `public void `[`begin`](#class_s_c16_i_s740_1a2914d7b2eb94a0d9413c295611814cd2)`(int baudRate,uint8_t options)` 

Set up the chip. You must do this before reading or writing.

#### Parameters
* `baudRate` the baud rate (see below)

* `options` The number of data bits, parity, and stop bits

You can call begin more than once if you want to change the baud rate. The FIFOs are cleared when you call begin.

Available baud rates depend on your oscillator, but with a 1.8432 MHz oscillator, the following are supported: 50, 75, 110, 134.5, 150, 300, 600, 1200, 1800, 2000, 2400, 3600, 4800, 7200, 9600, 19200, 38400, 57600, 115200

The valid options in standard number of bits; none=N, even=E, odd=O; number of stop bits format: OPTIONS_8N1, OPTIONS_8E1, OPTIONS_8O1 OPTIONS_8N2, OPTIONS_8E2, OPTIONS_8O2 OPTIONS_7N1, OPTIONS_7E1, OPTIONS_7O1 OPTIONS_7N2, OPTIONS_7E2, OPTIONS_7O2

#### `public inline void `[`blockOnOverrun`](#class_s_c16_i_s740_1a146f0afeb2d5efe71d2c44285a8260dd)`(bool value)` 

Defines what should happen when calls to [write()](#class_s_c16_i_s740_1ae95bfe10661800710fb0c3ed399dd6da)/print()/println()/printlnf() that would overrun the buffer.

blockOnOverrun(true) - this is the default setting. When there is no room in the buffer for the data to be written, the program waits/blocks until there is room. This avoids buffer overrun, where data that has not yet been sent over serial is overwritten by new data. Use this option for increased data integrity at the cost of slowing down realtime code execution when lots of serial data is sent at once.

blockOnOverrun(false) - when there is no room in the buffer for data to be written, the data is written anyway, causing the new data to replace the old data. This option is provided when performance is more important than data integrity.

#### `public virtual int `[`available`](#class_s_c16_i_s740_1a9e1cf50a2edb0d20e801ce85b17dff79)`()` 

Returns the number of bytes available to read from the serial port.

This is a standard Arduino/Wiring method for Stream objects.

#### `public virtual int `[`availableForWrite`](#class_s_c16_i_s740_1a5a74760f6ca7cf61f72fdcf9f104b5f2)`()` 

Returns the number of bytes available to write into the TX FIFO.

#### `public virtual int `[`read`](#class_s_c16_i_s740_1a2e8cf54d3fc3b8d4a06ea7e0f99fe6d6)`()` 

Read a single byte from the serial port.

#### Returns
a byte value 0 - 255 or -1 if no data is available.

This is a standard Arduino/Wiring method for Stream objects.

#### `public virtual int `[`peek`](#class_s_c16_i_s740_1a6f917ad00ab6a191d40966d65f0f4f9a)`()` 

Read a single byte from the serial port, but do not remove it so it can be read again.

#### Returns
a byte value 0 - 255 or -1 if no data is available.

This is a standard Arduino/Wiring method for Stream objects.

#### `public virtual void `[`flush`](#class_s_c16_i_s740_1a4dc8f7f3e110f593bae82b7ebf3086cd)`()` 

Block until all serial data is sent.

This is a standard Arduino/Wiring method for Stream objects.

#### `public virtual size_t `[`write`](#class_s_c16_i_s740_1ae95bfe10661800710fb0c3ed399dd6da)`(uint8_t c)` 

Write a single byte to the seria; port.

#### Parameters
* `c` The byte to write. Can write binary or text data.

This is a standard Arduino/Wiring method for Stream objects.

#### `public uint8_t `[`readRegister`](#class_s_c16_i_s740_1a04816f20154a877aa8b69106faedb0e6)`(uint8_t reg)` 

Read a register.

#### Parameters
* `reg` The register number to read. Note that this should be the register 0 - 16, before shifting for channel.

#### `public bool `[`writeRegister`](#class_s_c16_i_s740_1af209b4f8aebfc6aabfd4b716fb96d975)`(uint8_t reg,uint8_t value)` 

Write a register.

#### Parameters
* `reg` The register number to write. Note that this should be the register 0 - 16, before shifting for channel.

* `value` The value to write

#### `protected TwoWire & `[`wire`](#class_s_c16_i_s740_1a1bcb2e3f74d01dc0c6296da93e6c9078) 

#### `protected int `[`addr`](#class_s_c16_i_s740_1a4712027447ef4c0654a134b0bd0e7842) 

#### `protected int `[`intPin`](#class_s_c16_i_s740_1a3a4b24cfd08206f9886dcf6fe4df7464) 

#### `protected int `[`oscillatorHz`](#class_s_c16_i_s740_1ade63edce36c9035767bda30d1310cc9b) 

#### `protected bool `[`hasPeek`](#class_s_c16_i_s740_1a00eeddab159d76a80a698be224aedab5) 

#### `protected uint8_t `[`peekByte`](#class_s_c16_i_s740_1ab60b262f76c76efeb58bfcab9bae68a8) 

#### `protected bool `[`writeBlocksWhenFull`](#class_s_c16_i_s740_1a867c8bbf95666bb2eb208cc328bba7cc) 

Generated by [Moxygen](https://sourcey.com/moxygen)